/* Copyright 2009, UCAR/Unidata and OPeNDAP, Inc.
   See the COPYRIGHT file for more information. */

#ifndef CEPARSELEX_H
#define CEPARSELEX_H

#include <ctype.h>

typedef void* Object;

#define YYSTYPE Object
/*! Specifies CEparsestate. */
typedef struct CEparsestate {
    OClist* refs; /* oclist<Projectionclause*> */
    char errorbuf[1024];
    int errorcode;
    OCconnection* conn;
    struct CElexstate {
        char* input;
        char* next; /* next char in uri.query */
        char* yytext;
        int lineno;
        OClist* reclaim; /* for reclaiming token strings */
        struct CElasttoken {
            char* text;
            int token;
        } lasttoken;
    } lexstate;
} CEparsestate;

#define MAXPATHLENGTH 1024

typedef struct Pathsegment {
    char* name;
    OClist* indices;
} Pathsegment;

/****************************/

extern void proj_clause(CEparsestate*, Object opath);
extern Object pathname(CEparsestate*, Object opath, Object osegment);
extern Object pathsegment(CEparsestate*, Object oname, Object oindices);
extern Object array_indices(CEparsestate*, Object oindices, Object oindex);
extern Object array_index(CEparsestate*, Object ofirst, Object ostride, Object olast);

extern int celex(YYSTYPE* lvalp, CEparsestate* state);

#endif /*CEPARSELEX_H*/
